open Ast
open Helper
open Execute

let print = false

type action = PrintBytecode | Execute | PrintCode

let _ =
  let action =
    if Array.length Sys.argv > 1 then
      List.assoc Sys.argv.(1) [("-b", PrintBytecode);
             ("-e", Execute);
             ("-p", PrintCode)]
    else
      Execute in
  let lexbuf = Lexing.from_channel stdin in
  let program = Parser.program Scanner.token lexbuf in
  match action with
    | PrintBytecode -> Helper.print_bp (Compiler.translate program)
    | Execute -> Execute.run (Compiler.translate program)
    | PrintCode -> let listing = Printer.string_of_program program in
       print_string listing
